Attribute VB_Name = "modDebugDB"
Option Explicit

' Use this global to store the database handle
Private dbDebug As Long

Public Type tDebugRecord
        Message As String
End Type

Public Sub DebugDatabase(msg As String)
   Dim debugRecord As tDebugRecord
   OpenDebugDatabase
   
   If dbDebug <> 0 Then
      'We successfully opened the database
      debugRecord.Message = msg
      WriteDebugRecord debugRecord
      PDBClose dbDebug
   Else
      MsgBox "Could not open the debug database."
   End If
   
End Sub


Private Function PalmIDtoLong(PalmID As String) As Long
    Dim myLng As Long, Counter As Integer
  
    If Len(PalmID) = 4 Then
        
        For Counter = 1 To Len(PalmID)
            myLng = myLng * 256 + Asc(Mid(PalmID, Counter, 1))
        Next Counter
        
        PalmIDtoLong = myLng
        
    Else
        PalmIDtoLong = 0
    End If
End Function


Private Function WriteDebugRecord(dbRecord As tDebugRecord) As Boolean

        'Create a new record in dbDebug using the schema.
        PDBCreateRecordBySchema dbDebug
                                           
        'Write the data to the new record.
        WriteDebugRecord = PDBWriteRecord(dbDebug, VarPtr(dbRecord))
        
        'Update the new record.
        PDBUpdateRecord dbDebug
End Function



Private Sub OpenDebugDatabase()

   ' Try and open the database
   #If APPFORGE Then
   dbDebug = PDBOpen(ByTypeCreator, "afdebug", 0, 0, PalmIDtoLong("DATA"), _
                     PalmIDtoLong("DBUG"), afModeReadWrite)
   #Else
   dbDebug = PDBOpen(ByTypeCreator, App.Path & "\afdebug", 0, 0, _
                     PalmIDtoLong("DATA"), PalmIDtoLong("DBUG"), _
                     afModeReadWrite)
   #End If

   If dbDebug = 0 Then
     'Assume the database does not exist and attempt to create it
     #If APPFORGE Then
       'Create new database (if on the device)
       dbDebug = PDBCreateDatabase("afdebug", PalmIDtoLong("DATA"), _
                                   PalmIDtoLong("DBUG"))
     #Else
       'Create new database (if on the PC)
       dbDebug = PDBCreateDatabase(App.Path & "\afdebug", _
                                   PalmIDtoLong("DATA"), _
                                   PalmIDtoLong("DBUG"))
     #End If
     
     If dbDebug <> 0 Then
      'Create the debug table
      PDBCreateTable dbDebug, "DebugTable", "Message String"
     Else
        MsgBox "Could not create database."
     End If
     
   End If

End Sub

Public Function DeleteDebugDatabase() As Boolean
    Dim bResult As Boolean
    #If APPFORGE Then
      'Delete the database (if on the device)
      bResult = PDBDeleteDatabase("afdebug", 0, 0)
    #Else
      'Delete the database (if on the PC)
      bResult = PDBDeleteDatabase(App.Path & "\afdebug", 0, 0)
    #End If
    
    DeleteDebugDatabase = bResult

End Function

